"""
humaan

Usage:
    humaan hello
    humaan -h | --help
    humaan --version

Options:
    -h, --help          Show this screen.
    --version           Show version.

Examples:
    humaan hello

Help:
    for help using this tool, please open an issue on the GitHub repository:
    https://github.com/humaan-ai/cli
"""

from inspect import getmembers, isclass

from docopt import docopt

from . import __version__ as VERSION

def main():
    """Main CLI entrypoint."""
    import humaan.commands
    options = docopt(__doc__, version=VERSION)

    # Here we'll try to dynamically match the command the user is trying to run
    # with a pre-defined command class we've already created.
    for (k, v) in options.items():
        if hasattr(humaan.commands, k) and v:
            module =getattr(humaan.commands, k)
            humaan.commands = getmembers(module, isclass)
            command = [command[1] for command in humaan.commands if command[0] != 'Base'][0]
            command = command(options)
            command.run()